unit RWCUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,JPEG, Grids, Outline, FormRgn, registry, mmsystem;

const
 {    
  " " .176}
 B0:array [0..18] of byte =(27,8,19,0,11,22,3,14,25,6,17,28,9,20,2,13,24,5,16);

type
  TForm2 = class(TForm)
    FormRegion1: TFormRegion;
    PictExtRgn1: TPictExtRgn;
    Timer1: TTimer;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
    Moon : tIcon;
    DOG  : tBitmap;
    function CalcMoon:hIcon;
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  WalpapersDirectory : string;

implementation

{$R *.DFM}
{$R resours}
{$I const.inc}

function TForm2.CalcMoon:hIcon;
var
  Year, Month, Day, Hour, Min, Sec, MSec: Word;
  MoonDay : word;
begin
   {  }
   DecodeDate(Date,Year,Month,Day);
   DecodeTime(Date, Hour, Min, Sec, MSec);
   MoonDay:=B0[Year-(Year div 19)*19]+Month+Day;
   if Hour>12 then inc(MoonDay);  {    ,    }
   while MoonDay>=30 do dec(Moonday,30);

   CalcMoon:=
     LoadImage(HInstance,pchar( format('moon%d',[MoonDay])),IMAGE_ICON,16,16,LR_DEFAULTCOLOR);
end;

function Rand(n:integer):integer;  //  
var
  Hour, Min, Sec, i: Word;
begin
  timeGetTime;
  DecodeTime(Now, Hour, Min, Sec, i);
  Randomize;
  for i:=0 to  Sec do Random;
  Rand:=Random(n);
end;

{      ,   }
function NextFileName(var num:integer;path:string) : string;
var
 SearchRec : tSearchRec;
 Res : integer;
 List   : TStringList;
begin
 //  
 List:=TStringList.Create;
 Res := FindFirst(path,0, SearchRec);
 while Res = 0 do
  begin
   List.Add(SearchRec.Name);
   Res := FindNext(SearchRec);
  end;
 FindClose(SearchRec);

 if List.Count<>0
  then begin
    inc (num);
    if num>List.Count then num:=1;
    NextFileName:=List[num]
  end
  else NextFileName:='';
 List.Free;
end;
{        }
function RandomFileName(path:string) : string;
var
 SearchRec : tSearchRec;
 Res : integer;
 List   : TStringList;
begin
 //  
 List:=TStringList.Create;
 Res := FindFirst(path,0, SearchRec);
 while Res = 0 do
  begin
   List.Add(SearchRec.Name);
   Res := FindNext(SearchRec);
  end;
 FindClose(SearchRec);

 if List.Count<>0
  then RandomFileName:=List[Rand(List.Count)]
  else RandomFileName:='';
 List.Free;
end;

{    filename}
function RandomRow (filename:string):string;
var
 List  : TStringList;
 f     : text;
 s     : string;
begin
 List:=TStringList.Create;
 Assign(f,FileName);
 {$I-} Reset(f);
 while not eof(f) do begin
   ReadLn(f,s);
   List.Add(s);
 end;
 Close(f);
 if List.Count<>0
  then RandomRow:=List[Rand(List.Count)]
  else RandomRow:='';
 List.Free;
end;

{ , , etc}
procedure TForm2.Timer1Timer(Sender: TObject);
const Work : boolean = false;
var
  JPEGImage : TJPEGImage;
  Bitmap    : TBitmap;
  FileName  : string;
  buffer    : array[0..100] of char;
  Reg,Reg1  : TRegistry;
  PicNum    : integer;    //  
begin
 if Work then Exit;
 Work:=true;
 Reg := TRegistry.Create;
  try
   Reg.RootKey := HKEY_CURRENT_USER;
   if Reg.OpenKey(RegPath,false)
    then begin
     {          Windows}
     if Reg.ValueExists(ChangeSounds)and Reg.ReadBool(ChangeSounds)
      then begin
        Reg1 := TRegistry.Create;
        try
       {   }
        if Reg.ValueExists(StartSoundPath)
         then begin
          FileName:=RandomFileName(Reg.ReadString(StartSoundPath)+'\*.wav');
          if FileName<>'' then begin
             Reg1.RootKey := HKEY_CURRENT_USER;
             if Reg1.OpenKey('AppEvents\Schemes\Apps\.Default\SystemStart\.Current',false)
              then Reg1.WriteString('',Reg.ReadString(StartSoundPath)+'\'+FileName);
          end;
         end;
        {   }
        if Reg.ValueExists(QuitSoundPath)
         then begin
          FileName:=RandomFileName(Reg.ReadString(QuitSoundPath)+'\*.wav');
          if FileName<>'' then begin
             Reg1.RootKey := HKEY_CURRENT_USER;
             if Reg1.OpenKey('AppEvents\Schemes\Apps\.Default\SystemExit\.Current',false)
              then Reg1.WriteString('',Reg.ReadString(QuitSoundPath)+'\'+FileName);
          end;
         end;
        finally
         Reg1.CloseKey;
         Reg1.Free;
        end; {try}
      end;

     {   }
     if Reg.ValueExists(ChangeHintMyComputer)and
        Reg.ReadBool(ChangeHintMyComputer) and
        Reg.ValueExists(MyCompTextFile)
       then begin
        Reg1 := TRegistry.Create;
        try
         Reg1.RootKey := HKEY_CLASSES_ROOT;
         if Reg1.OpenKey('CLSID\{20D04FE0-3AEA-1069-A2D8-08002B30309D}',false)
          then Reg1.WriteString('InfoTip',RandomRow(Reg.ReadString(MyCompTextFile)));
        finally
         Reg1.CloseKey;
         Reg1.Free;
        end;
       end; {   }
     { }
     if Reg.ValueExists(ChangeWallpaper) and
        Reg.ReadBool(ChangeWallpaper) and
        Reg.ValueExists(PicturesPath)
       then begin
        WalpapersDirectory:=Reg.ReadString(PicturesPath);
        if Reg.ValueExists(RandomWallpapper) and
           Reg.ReadBool(RandomWallpapper)
          then FileName:=RandomFileName(WalpapersDirectory+'\*.jpg')
          else begin
            if Reg.ValueExists(LastPictureNumber)
             then PicNum:=Reg.ReadInteger(LastPictureNumber)
             else PicNum:=1;
            FileName:=NextFileName(PicNum,WalpapersDirectory+'\*.jpg');
            Reg.WriteInteger(LastPictureNumber,PicNum);
          end;
        if FileName<>''
          then begin
           Reg.WriteString(LastPicture,FileName);
           JPEGImage:=TJPEGImage.Create;
           JPEGImage.LoadFromFile(WalpapersDirectory+'\'+FileName);

           GetWindowsDirectory(@buffer,sizeof(buffer));
           FileName:=buffer+'\desk.bmp';
           Bitmap:=TBitmap.Create;
           Bitmap.Assign(JPEGImage);
           Bitmap.SaveToFile(FileName);
           Bitmap.FreeImage;
           JPEGImage.Free;

           Reg.RootKey := HKEY_CURRENT_USER;
           if Reg.OpenKey('\Control Panel\Desktop',True)
            then begin
             Reg.WriteString('Wallpaper', FileName );
             Reg.WriteString('WallpaperStyle', '2' );
             Reg.WriteString('TileWallpaper', '0' );
             SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, nil, SPIF_SENDWININICHANGE );
            end;
          end
          else Application.MessageBox('     ',
                 ' ',MB_ICONSTOP);
       end { }
    end
    else Application.MessageBox('   .  ',
                 ' ',MB_ICONSTOP);
  finally
   Reg.CloseKey;
   Reg.Free;
  end;

 Application.Terminate;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  Left:=1;
  Top:=Screen.DesktopHeight-Height-40;
  Moon:=TIcon.Create;
  Moon.Handle:=CalcMoon;

  DOG:=TBitmap.Create;
  Dog.Handle:=LoadImage(HInstance,'silver_dog',IMAGE_Bitmap,100,104,LR_DEFAULTCOLOR);
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
  Moon.Free;
  Dog.Free;
end;

procedure TForm2.FormPaint(Sender: TObject);
begin
 Canvas.Draw(0,0,Dog);
 Canvas.Draw(70,20,Moon);
end;

end.
